unit uMainForm;

interface

uses
  uImplDLL_WIKA_P30,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Spin;

type
  TForm1 = class(TForm)
    ButtonOpenCOM: TButton;
    ButtonCloseCOM: TButton;
    GroupBox4: TGroupBox;
    RichEditInfo: TRichEdit;
    PanelRead: TPanel;
    btnReadTemperature: TButton;
    btnReadPressure: TButton;
    btnReadDeviceInfo: TButton;
    SpinEditComNr: TSpinEdit;
    procedure ButtonOpenCOMClick(Sender: TObject);
    procedure ButtonCloseCOMClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnReadDeviceInfoClick(Sender: TObject);
    procedure btnReadPressureClick(Sender: TObject);
    procedure btnReadTemperatureClick(Sender: TObject);
  private
    mHandleP30: integer;
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
// -----------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
  InitDLLroutines;
end;
// -----------------------------------------------------------------------------
procedure TForm1.ButtonOpenCOMClick(Sender: TObject);
begin
  mHandleP30 := P30_OpenPort(SpinEditComNr.Value);
  if (mHandleP30 < 0) then
    ShowMessage('Error: ' + IntToStr(mHandleP30));
end;
// -----------------------------------------------------------------------------
procedure TForm1.btnReadPressureClick(Sender: TObject);
var
  Status  : SmallInt;
  Pressure: Single;
begin
  Status := P30_ReadPressure(mHandleP30, Pressure);
  if (Status < 0) then
    PanelRead.Caption := 'Fehler : ' + IntToStr(Status)
  else
    PanelRead.Caption := FloatToStr(Pressure);
end;
// -----------------------------------------------------------------------------
procedure TForm1.btnReadTemperatureClick(Sender: TObject);
var
  Status      : SmallInt;
  Temperature : Single;
begin
  Status := P30_ReadTemperature(mHandleP30, Temperature);
  if (Status < 0) then
    PanelRead.Caption := 'Fehler : ' + IntToStr(Status)
  else
    PanelRead.Caption := FloatToStr(Temperature);
end;
// -----------------------------------------------------------------------------
procedure TForm1.ButtonCloseCOMClick(Sender: TObject);
var
  Status: ShortInt;
begin
  Status := P30_ClosePort(mHandleP30);
  if (Status < 0) then
    MessageDlg('Error: ' + IntToStr(Status), mtError, [mbOK], 0);
end;
// -----------------------------------------------------------------------------
procedure TForm1.btnReadDeviceInfoClick(Sender: TObject);
var
  s         : string;
  Status    : ShortInt;
  DeviceInfo: tDeviceInfo;
begin
  RichEditInfo.Clear;
  Status := P30_ReadDeviceInfo(mHandleP30, DeviceInfo);
  if (Status >= 0) then
  begin
    s := FloatToStr(DeviceInfo.RangeStart);
    if (DeviceInfo.UnitStart <> DeviceInfo.UnitEnd) then
      s := s + ' ' + string(DeviceInfo.UnitStart);

    s := s + ' ... '
      + FloatToStr(DeviceInfo.RangeEnd) + ' '
      + string(DeviceInfo.UnitEnd);

    if DeviceInfo.IsAbsolute then
      s := s + ' abs.'
    else
      s := s + ' rel.';

    RichEditInfo.Lines.Add('Range        : ' + s);
    RichEditInfo.Lines.Add('Firmware     : '
      + string(DeviceInfo.FirmwareVersion));
    RichEditInfo.Lines.Add('Serialnumber : '
      + string(DeviceInfo.SerialNumber));
    RichEditInfo.Lines.Add('Productnumber     : '
      + string(DeviceInfo.ProductNumber));
    RichEditInfo.Lines.Add('Date of Manufacturing: ' +
      Format('%.2d.%.2d.%.2d', [
      DeviceInfo.ProductionD, DeviceInfo.ProductionM, DeviceInfo.ProductionY]));
  end
  else
    RichEditInfo.Lines.Add('Error: ' + IntToStr(Status));
end;
// -----------------------------------------------------------------------------
end.
